{    var   : }
{  MA, N, ML, MU, NLEAD, Z }
Unit ammhe_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, AFB2E_p, UTAFSI_p;

procedure ammhe(var A :Array of Extended; var MA :Integer;
                var N :Integer; var ML :Integer; var MU :Integer;
                var NLEAD :Array of Integer; var B :Array of Extended;
                MB :Integer; NN :Integer; var RCOND :Extended;
                var Z :Array of Extended; var IERR :Integer); 
implementation

procedure ammhe(var A :Array of Extended; var MA :Integer;
                var N :Integer; var ML :Integer; var MU :Integer;
                var NLEAD :Array of Integer; var B :Array of Extended;
                MB :Integer; NN :Integer; var RCOND :Extended;
                var Z :Array of Extended; var IERR :Integer);
var
I,I0,I1,J,J0,J1,JJ,K,KB,KP1,LL,LM,M,NM1 :Integer;
S,T :Extended;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330,_340,_350;
begin
{ ************************************************* }
{    ,   -   }
{     ,          }
{       .         }
{ ************************************************* }
RCOND := 0.0e0;

{        }
S := 0.0e0;
_10:

{         N }
if ( N >= 1 ) and ( MA >= 1 ) 
 then goto _30;
_20:
IERR := 65;
UTAFSI('A','M','M','H','E',IERR);
goto _350;
_30:
if ( NN >= 1 ) and ( MB >= 1 ) 
 then goto _40;
goto _20;
_40:
IERR := 0;
AFB2E(A,MA,N,ML,MU,NLEAD,RCOND,Z,IERR);
if ( IERR <> 0 ) 
 then UTAFSI('A','M','M','H','E',IERR);
if ( IERR <= 0 ) 
 then goto _50;
goto _350;
_50:
NM1 := N - 1;
M := ML + MU + 1;
for I:=1 to N do
 begin
  J0 := Max0(1,I-ML);
  J1 := Min0(N,I+ML+MU);
  for J:=J0 to J1 do
   begin
    K := J - I + ML + 1;
    Z[J-1] := A[(I-1)+(K-1)*MA];
_60:
   end;
  for J:=J0 to J1 do
   begin
    A[(I-1)+(J-1)*MA] := Z[J-1];
_70:
   end;
_80:
 end;
for J:=1 to N do
 begin
  I0 := Max0(1,J-ML-MU);
  I1 := Min0(N,J+ML);
  for I:=I0 to I1 do
   begin
    K := I - J + M;
    Z[K-1] := A[(I-1)+(J-1)*MA];
_90:
   end;
  for I:=I0 to I1 do
   begin
    K := I - J + M;
    A[(K-1)+(J-1)*MA] := Z[K-1];
_100:
   end;
_110:
 end;
for LL:=1 to NN do
 begin

{     L*=(LL) }
  if ( ML = 0 ) 
   then goto _180;
  if ( NM1 < 1 ) 
   then goto _180;
  for K:=1 to NM1 do
   begin
    LM := Min0(ML,N-K);
    JJ := NLEAD[K-1];
    T := B[(JJ-1)+(LL-1)*MB];
    if ( JJ = K ) 
     then goto _120;
    B[(JJ-1)+(LL-1)*MB] := B[(K-1)+(LL-1)*MB];
    B[(K-1)+(LL-1)*MB] := T;
_120:
    I0 := M + 1;
    I1 := M + LM;
    I := (LM Mod 4) + M;
    if ( I = M ) 
     then goto _140;
    for JJ:=I0 to I do
     begin
      KP1 := JJ + K - M;
      B[(KP1-1)+(LL-1)*MB] := B[(KP1-1)+(LL-1)*MB] + T*A[(JJ-1)+(K-1)*MA];
_130:
     end;
_140:
    I := I + 1;
    if ( I > I1 ) 
     then goto _160;
    JJ := I;
    while ( JJ<=I1 ) do
     begin
      KP1 := JJ + K - M;
      B[(KP1-1)+(LL-1)*MB] := B[(KP1-1)+(LL-1)*MB] + T*A[(JJ-1)+(K-1)*MA];
      B[(KP1+1-1)+(LL-1)*MB] := B[(KP1+1-1)+(LL-1)*MB] + T*A[(JJ+1-1)+(K-1)*MA];
      B[(KP1+2-1)+(LL-1)*MB] := B[(KP1+2-1)+(LL-1)*MB] + T*A[(JJ+2-1)+(K-1)*MA];
      B[(KP1+3-1)+(LL-1)*MB] := B[(KP1+3-1)+(LL-1)*MB] + T*A[(JJ+3-1)+(K-1)*MA];
_150:
      inc(JJ,4);
     end;
_160:
_170:
   end;
_180:

{     U*= }
  for KB:=1 to N do
   begin
    K := N + 1 - KB;
    if ( A[(M-1)+(K-1)*MA] <> 0.0e0 ) 
     then goto _200;
    if ( B[(K-1)+(LL-1)*MB] <> 0.0e0 ) 
     then goto _190;
    B[(K-1)+(LL-1)*MB] := 1.0e0;
    goto _210;
_190:
    IERR := 67;
    UTAFSI('A','M','M','H','E',IERR);
    goto _280;
_200:
    B[(K-1)+(LL-1)*MB] := B[(K-1)+(LL-1)*MB]/A[(M-1)+(K-1)*MA];
_210:
    T := B[(K-1)+(LL-1)*MB];
    LM := Min0(K,M) - 1;
    if ( LM < 1 ) 
     then goto _250;
    I0 := M - LM;
    I1 := M - 1;
    I := (LM Mod 4) + I0 - 1;
    if ( I < I0 ) 
     then goto _230;
    for JJ:=I0 to I do
     begin
      KP1 := JJ + K - M;
      B[(KP1-1)+(LL-1)*MB] := B[(KP1-1)+(LL-1)*MB] - T*A[(JJ-1)+(K-1)*MA];
_220:
     end;
_230:
    I := I + 1;
    if ( I > I1 ) 
     then goto _250;
    JJ := I;
    while ( JJ<=I1 ) do
     begin
      KP1 := JJ + K - M;
      B[(KP1-1)+(LL-1)*MB] := B[(KP1-1)+(LL-1)*MB] - T*A[(JJ-1)+(K-1)*MA];
      B[(KP1+1-1)+(LL-1)*MB] := B[(KP1+1-1)+(LL-1)*MB] - T*A[(JJ+1-1)+(K-1)*MA];
      B[(KP1+2-1)+(LL-1)*MB] := B[(KP1+2-1)+(LL-1)*MB] - T*A[(JJ+2-1)+(K-1)*MA];
      B[(KP1+3-1)+(LL-1)*MB] := B[(KP1+3-1)+(LL-1)*MB] - T*A[(JJ+3-1)+(K-1)*MA];
_240:
      inc(JJ,4);
     end;
_250:
_260:
   end;
_270:
 end;
_280:
for J:=1 to N do
 begin
  I0 := Max0(1,J-MU-ML);
  I1 := Min0(N,J+ML);
  for I:=I0 to I1 do
   begin
    K := I - J + M;
    Z[I-1] := A[(K-1)+(J-1)*MA];
    A[(K-1)+(J-1)*MA] := 0.0e0;
_290:
   end;
  for I:=I0 to I1 do
   begin
    A[(I-1)+(J-1)*MA] := Z[I-1];
_300:
   end;
_310:
 end;
for I:=1 to N do
 begin
  J0 := Max0(1,I-ML);
  J1 := Min0(N,I+MU+ML);
  for J:=J0 to J1 do
   begin
    K := J - I + ML + 1;
    Z[K-1] := A[(I-1)+(J-1)*MA];
    A[(I-1)+(J-1)*MA] := 0.0e0;
_320:
   end;
  for J:=J0 to J1 do
   begin
    K := J - I + ML + 1;
    A[(I-1)+(K-1)*MA] := Z[K-1];
_330:
   end;
_340:
 end;
_350:
end;

end.
